﻿/****************************************************************************
* Aplicativo : SMTGeR... Servidor de Microterminais Gertec - Restaurante    *
* Autor		 : Ana Lúcia S. Melo 										    *
* Referência : SMTGeR - Programa Servidor para Micro Terminais              *
* Data       : 10/09/08													    *
* Ambiente   : Visual C# 2005 (Express Edition)                            *
* Fonte      : Form1.cs														*
* Objetivo   : Exemplificar uma aplicação para microterminais simulando um	*
*			   programa de restaurante.									   	*
* Notas		 : Este fonte destina-se exclusivamente como material de	    *
*			   auxilio a desenvolvedores de aplicações para produtos Gertec.*
****************************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Runtime.InteropServices;
using System.Threading;
using System.Globalization;
using System.IO;



namespace SMTGeR
{
  
    public partial class Form1 : Form
    {

        private pmtger Hpmtg;
        private structs structs;
        private Ids ids;
       // private estrutura estruturas = new estrutura();


        /****Variaveis globais****/
        int COMUNICATION_MSG = 0x0400 + 1 ;
        int CONNECT_MSG = 0x0400 + 2;

        int [] passo = new int [256];
        string[] palavra = new string[256];
        int [] peso = new int[256];
	    int cancela;
        public string strbanco;
        int drok, pesok;
        int LParamLo;
        int LParamHi;
        int conta = 0;
        int[] tabConect = new int[256];

        public int[] ipdll = new int[255];
        public int [] NumeroProd = new int[256];
        public structs.PedidoType[] PedidoG = new structs.PedidoType[256];
       
        /*****************************/

        public Form1()
        {                        

            // Inicializa algumas variaveis
            for (int i = 0; i <= 255; i++)
            {
                PedidoG[i].Cesta = new structs.Produto[256];
                palavra[i] = "";
            }
            peso[0] = 0;
            InitializeComponent();
           

        }
        /********************************************************************************************************
	    * Função: btIniciar																						*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 10/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*
	    * Descrição: Responsavel por iniciar o programa		            										*	
	    *																										*
	    *********************************************************************************************************/
        private void btIniciar_Click(object sender, EventArgs e)
        {   
            //Efetua a abertura da DLL
            if (btIniciar.Text == "Iniciar")
            {
                if (Conecta() == 1)
                {                   
                    if (pmtger.mt_startserver(this.Handle, CONNECT_MSG, COMUNICATION_MSG) > 0)
                    {
                        lbInform.Text = "";
                        btIniciar.Text = "Terminar";

                        bdAccess.Enabled = false;
                        bdSql.Enabled = false;

                        label1.Enabled = false;
                        label2.Enabled = false;
                        label3.Enabled = false;
                        label4.Enabled = false;
                        txServidor.Enabled = false;
                        txBanco.Enabled = false;
                        txUser.Enabled = false;
                        txPass.Enabled = false;

                        label5.Enabled = false;
                        label6.Enabled = false;
                        txBancoAc.Enabled = false;
                        txWay.Enabled = false;
                   }else
                    {
                        lbInform.Text = "Falha ao iniciar servidor";
                    }
                }
            }
            // Se o menu estiver como "Terminar" a DLL é finalizada
            else
            {
                pmtger.mt_finishserver();
                bdAccess.Enabled = true;
                bdSql.Enabled = true;
                btIniciar.Text = "Iniciar";
                if (bdSql.Checked == true)
                {
                    bdSql.Checked = true;
                }
                else
                {
                    bdAccess.Checked = true;
                }

            }
        }

        /********************************************************************************************************
	    * Função: Conecta																						*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 10/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*
	    * Descrição: Responsavel pela conexão com o banco de print[j]												*	
	    *																										*
	    *********************************************************************************************************/
        private byte Conecta() 
        {
            string strConection, Servidor, Banco, Uid, PWD;
           
            try {
                //define a string de conexao com provedor caminho e nome do banco de print[j]
                strConection = " ";
                //Verifica qual o banco de print[j] que será usado
                if (bdAccess.Checked == true)
                {
                    strConection = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + txWay.Text + "\\" + txBancoAc.Text + lbmdb.Text + ";";
                }
                else if (bdSql.Checked == true)
                {
                    //Retira os espaços 
                    Servidor = txServidor.Text.Trim();
                    Banco = txBanco.Text.Trim();
                    Uid = txUser.Text.Trim();
                    PWD = txPass.Text.Trim();
                    //Verifica se os campos user e senha estão preeenchidos
                    if ((Uid.Length == 0) || (PWD.Length == 0))
                    {
                        strConection = "Provider=sqloledb;Data Source=" + Servidor + "; Initial Catalog=" + Banco + ";Integrated Security=SSPI;";
                    }
                    else
                    {
                        strConection ="Provider=SQLOLEDB; Data Source= " + Servidor + "; Initial Catalog=" + Banco + ";User Id= " + Uid + "; Password= " + PWD + ";";
                    }
                }
                strbanco = strConection;
                //Nesta aplicação será utilizado OleDb para conexao com o banco de print[j]
                OleDbConnection con = new OleDbConnection(strConection);
                con.Open();
                con.Close();
                return 1;
            }
            catch {
                return 0;
            }
        }

       /********************************************************************************************************
       * Função: Form1_Load																						*
       *********************************************************************************************************
       *																										*
       * Data de Criação: 17/09/2008																			*
       *																										*
       * Retorno: void																							*
       *																										*
       * Descrição: Responsavel por iniciar o programa e funções iniciais								    *	
       *																										*
       *********************************************************************************************************/
        private void Form1_Load(object sender, EventArgs e)
        {
            structs = new structs();
            Hpmtg = new pmtger();
            ids = new Ids(); 
            //estruturas = new estrutura();
            
            for (int i = 0; i <= 255; i++)
            {
                for (int j = 0; j <= 255; j++)
                    PedidoG[i].Cesta[j].Obs = "";
            }
            
            //verifica em Properties.Settings o que deve ser gravado nos campos do banco de dados 
            if (Properties.ArqBanco.Default.bdbanco == 2) bdAccess.PerformClick();
            else
            {
                bdSql.Checked = false;
                bdSql.PerformClick();
            }
            
            // Carrega as informações salvas do banco nos devidos campos
            txServidor.Text = Properties.ArqBanco.Default.sqlServidor;
            txBanco.Text = Properties.ArqBanco.Default.sqlBanco;
            txUser.Text = Properties.ArqBanco.Default.sqlUser ;
            txPass.Text = Properties.ArqBanco.Default.sqlPass ;

            txBancoAc.Text = Properties.ArqBanco.Default.mdbBanco;
            txWay.Text = Properties.ArqBanco.Default.mdbCaminho;

            
        }
        /********************************************************************************************************
        *  Função: TimerPasso																					*
        *********************************************************************************************************
        *                                                                                                       *
        * Data de Criação: 12/09/2008																			*
        * 																										*
        * Descrição: Responsável pela fases no microterminais e envio das telas							        *	
        * 																										*
        *********************************************************************************************************/
        public void TimerPasso(int IP)
        { 
            string MsgStr;
            try
            {
                /* switch (passo[IP])...: Verifica em qual fase o microterminal esta e mostra 
                 * a proxima tela ou a tela anterior */
                switch (passo[IP])
                {
                    case 0:
                        passo[IP]++;
                        break;
                    case 1:
                        pmtger.mt_formfeed(IP);
                        //Envia a 1ª tela ao terminal (Operador)
                        MsgStr = "Operador:";

                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 2:
                        pmtger.mt_formfeed(IP);
                        MsgStr = "Cartao:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 3:
                        pmtger.mt_formfeed(IP);
                        //Envia a 3ª tela ao terminal (Local)
                        MsgStr ="Local:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 4:
                        pmtger.mt_formfeed(IP);
                        //Envia a 4ª tela ao terminal (Guia)
                        MsgStr = "Guia:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 5:
                        pmtger.mt_formfeed(IP);
                        //Envia a 5ª tela ao terminal (Produto)
                        MsgStr = "Produto:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 6:
                        // Envia a tela de pedido
                        // Enviando a 1ª linha com a descrição do produto pedido
                        pmtger.mt_formfeed(IP);
                        MsgStr = PedidoG[IP].Cesta[NumeroProd[IP]].DescricaoProduto;
                        pmtger.mt_dispstr(IP, MsgStr);

                        // Enviando a 2ª linha com o valor do produto pedido
                        pmtger.mt_linefeed(IP);
                        pmtger.mt_carret(IP);
                        MsgStr = (PedidoG[IP].Cesta[NumeroProd[IP]].Valor).ToString("C");
                        pmtger.mt_dispstr(IP, MsgStr);

                        // Incluindo o local de digitação de Qtd posicionando o cursor
                        pmtger.mt_gotoxy(IP, 2, 10);
                        MsgStr = "Qtd:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                    case 7:
                        //Envia a tela de observação
                        pmtger.mt_formfeed(IP);
                        MsgStr =  "Observacao:";
                        pmtger.mt_dispstr(IP, MsgStr);
                        Thread.Sleep(200);
                        break;
                }
            }
            catch
            {
            }
        }
        /********************************************************************************************************
        * Função: WndProc																				        *
        *********************************************************************************************************
        *																										*
        * Data de Criação: 12/09/2008																			*
        *																										*
        * Descrição: Responsável pelo recebimento e envio de mensagens											*	
        *																										*
        *********************************************************************************************************/
        protected override void WndProc(ref Message m)
        {
            
            //recebe mensagens enviadas pelo terminal
            if (m.Msg == COMUNICATION_MSG)
            {
                // terminal que enviou a informação
                LParamLo = (m.LParam.ToInt32() << 16) >> 16; // lo order word
                LParamHi =  m.LParam.ToInt32()        >> 16; // hi order word
                structs.Arg_Com_SetupSerial configserial = new structs.Arg_Com_SetupSerial();
                configserial.Setup = new structs.TSetupSerial();
               
                byte[] buf = new byte[256];
                string msg;
                string buf2;
                int ptam, k, j;
                byte porta;
                int[] com = new int[1];
                byte [] bufbalanc = new byte[256];
                string balanca;
                byte [] recSerial = new byte[1];
                byte[] pesoserial = new byte[256];
                recSerial[0] = 0;
                double fserial;
                             
           

                /* ROTINA REFERENTE AO RECEBIMENTO DA SERIAL - BALANÇA */
                if ((int)m.WParam == Ids.IDbGetBinSerial)
                {
                    if (txComBalanca.Text.ToString() == "")
                    {
                        com[0] =  0;
                    }
                    else
                    {
                        com[0] = (int.Parse(txComBalanca.Text) - 1);
                    }
                    // armazena o tamanho
                    ptam = pmtger.mt_getserial(1, com, pesoserial);

                    if ((passo[LParamLo] == 6) && ((ckReqPeso.Checked == true) || ((peso[LParamLo] == 1) && (pesok == 1))))
                    {
                        pmtger.mt_gotoxy(LParamLo, 2, 10); //posiciona o cursor
                        // Rotina de troca de informação - QTD por PESO
                        msg = "Peso:      ";
                        pmtger.mt_dispstr(LParamLo, msg);
                        pmtger.mt_gotoxy(LParamLo, 2, 15);
                        Thread.Sleep(50);

                        if (pesok ==1)
                            balanca = System.Text.ASCIIEncoding.ASCII.GetString(pesoserial,2, int.Parse(txDigPeso.Text));
                        else 
                            balanca =System.Text.ASCIIEncoding.ASCII.GetString(pesoserial, int.Parse(txPosPeso.Text), int.Parse(txDigPeso.Text));
                        try
                        {
                            fserial = float.Parse(balanca) / 1000;
                            palavra[LParamLo] = fserial.ToString();
                            pmtger.mt_dispstr(LParamLo, fserial.ToString());
                            pesok = 0;
                        }
                        catch
                        {
                        }

                                 
                    }
                }

                /*RECEBE A CONFIGURAÇÃO DA SERIAL DO MICROTERMINAL*/
               /* if ((int)m.WParam == Ids.IDvGetSetupSerial)
                {                
                    if (pmtger.mt_getconfigserial(LParamLo, ref configserial) >= 1)
                    {
                        // Cada combo recebe sua respctiva configuração de serial
                        cbBaud.Text = configserial.Setup.baud.ToString();
                        cbBits.Text = configserial.Setup.bits.ToString();
                        if (configserial.Setup.parity == 0)
                        {
                            cbParidade.Text = "Nenhum";
                        }
                        else if (configserial.Setup.parity == 1)
                        {
                            cbParidade.Text = "Impar";
                        }
                        else if (configserial.Setup.parity == 2)
                        {
                            cbParidade.Text = "Par";
                        }
                        else if (configserial.Setup.parity == 3)
                        {
                            cbParidade.Text = "Marca";
                        }
                        else if (configserial.Setup.parity == 4)
                        {
                            cbParidade.Text = "Espaço";
                        }
                        cbStop.Text = configserial.Setup.stops.ToString();

                        if (configserial.Setup.handshaking == 0)
                        {
                            cbHand.Text = "Nenhum";
                        }
                        else if (configserial.Setup.handshaking == 1)
                        {
                            cbHand.Text = "CTS / RTS";
                        }
                    }
                }*/
                
                /** Recebe as teclas que foram digitadas **/
                if ((int)m.WParam == Ids.IDcGetCharTerm){
                    if ((pmtger.mt_getkey(LParamLo, buf)) > 0)
                    {
                        // buf contem o valor da tecla
                        buf2 = null;
                        buf2 = System.Text.ASCIIEncoding.ASCII.GetString(buf,0,1);
                        

                        if ((int.TryParse(buf2,out k)) || (buf2 =="0"))
                        {
                            // Verifica se no momento esta sendo pesado algum produto
                            // caso esteja o teclado não deve influenciar na pesagem
                            if (peso[LParamLo] == 0)
                            {
                                //armazena o que foi digitado na variavel "palavra[LParmLo]"
                                //onde LParamLo corresponde ao microterminal ativo no momento
                                palavra[LParamLo] = palavra[LParamLo]+buf2;
                                pmtger.mt_dispstr(LParamLo, buf2);
                            }
                        }
                        
                        //Caso tenha apertado a tecla "+" verifica se esta no passo 6 (inclusão da qtd do produto)
                        // e efetua o peso do produto atraves da balança conectada em determinada porta.						
                        if ((passo[LParamLo]==6 )&&(buf[0]== 43)){
                            peso[LParamLo]= 1;  //Prioriza pesagem ao inves de digitação
                            palavra[LParamLo] = "";
						    //Verifica a porta Com
						    if (txComBalanca.Text.ToString() == ""){
							    porta= 0;
						    }else{ 
							    porta = (byte)(int.Parse(txComBalanca.Text) - 1);
						    }
    						
						    //Verifica o comando de envio para receber o peso da balança
						    if (txComanPeso.Text.ToString() == ""){
							    recSerial[0] = 05;
						    }else{ 
							    int digpeso;
							    digpeso = int.Parse(txComanPeso.Text);
							    recSerial[0] =(byte)digpeso;
						    }
                           
                            pmtger.mt_setenableserial(LParamLo, porta, 1);
                            						        					
						    // Envia o comando para recebimento do peso
						    if (pmtger.mt_sendbinserial(LParamLo, porta,recSerial, 1) <= 0){
							    msg = "ERRO";
                                MessageBox.Show(msg);
                            }
                            else pesok = 1;
                            pmtger.mt_gotoxy(LParamLo, 2, 10); //posiciona o cursor
                            // Rotina de troca de informação - QTD por PESO
                            msg = "Peso:      ";
                            pmtger.mt_dispstr(LParamLo, msg);
                            pmtger.mt_gotoxy(LParamLo, 2, 15);
                       
						    Thread.Sleep(300); // Tempo de espera para atualização da balança
						    palavra[LParamLo] = "";                                      
    						
						}
                        else if (buf[0] == 8 || (buf[0] == 13 || buf[0] == 27))
                        {
                            /************************************************************
                            *   Se a tecla foi Backspace segue o seguinte procedimento	*
                            *************************************************************/
                            if (buf[0] == 8)
                            {
                                if (peso[LParamLo] == 0)
                                {
                                    if (palavra[LParamLo].Length > 0)
                                    {
                                        ptam = (palavra[LParamLo].Length);
                                        palavra[LParamLo] = palavra[LParamLo].Substring(0, ptam - 1);
                                        pmtger.mt_backspace(LParamLo);
                                    }
                                }

                            /***********************************************************
                            *   Se a tecla foi ENTER segue o seguinte procedimento     *
                            ************************************************************/
                            // O Enter se responsabilizará pelos passos que ocorem como passagem para proxima tela,
                            // confirmação do pedido, inclusão de observação, etc...
                            }
                            else if (buf[0] == 13)
                            {
                                //Verificação de cancelamento de item
                                if (cancela == 1)
                                {
                                    passo[LParamLo]--;
                                    palavra[LParamLo] = "";
                                    NumeroProd[LParamLo] = 1;
                                    TimerPasso(LParamLo);
                                    cancela = 0;

                                }
                                if (peso[LParamLo] == 1)
                                {
                                    peso[LParamLo] = 0;
                                }
                                switch (passo[LParamLo])
                                {
                                    case 0:
                                        passo[LParamLo] = 1;
                                        TimerPasso(LParamLo);
                                        palavra[LParamLo] = "";
                                        break;
                                    //{****OPERADOR****}
                                    case 1:
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";

                                        }
                                        else
                                            //Consulta o codigo do operador
                                            if (LancamentoUsuario(palavra[LParamLo], LParamLo, strbanco) == 1)
                                            {
                                                passo[LParamLo]++;
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                            else
                                            {
                                                //Caso não tenha um operador envia OPERADOR iNVALIDO!!!
                                                pmtger.mt_formfeed(LParamLo);
                                                msg = "    OPERADOR";
                                                pmtger.mt_dispstr(LParamLo, msg);

                                                pmtger.mt_linefeed(LParamLo);
                                                pmtger.mt_carret(LParamLo);
                                                msg = "    INVALIDO!!!";
                                                pmtger.mt_dispstr(LParamLo, msg);
                                                Thread.Sleep(300);
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                        break;
                                    /***CARTAO***/
                                    case 2:
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        else
                                        {
                                            //Consulta o codigo do cartao(comanda)
                                            if (LancamentoCartao(palavra[LParamLo], LParamLo, strbanco) == 1)
                                            {
                                                NumeroProd[LParamLo] = 1;
                                                passo[LParamLo]++;
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                            else
                                            {
                                                //Caso não tenha um cartão válido envia CARTAO INVALIDO!!!
                                                pmtger.mt_formfeed(LParamLo);
                                                msg = "     CARTAO";
                                                pmtger.mt_dispstr(LParamLo, msg);
                                                Thread.Sleep(100);
                                                pmtger.mt_linefeed(LParamLo);
                                                pmtger.mt_carret(LParamLo);
                                                msg = "    INVALIDO!!!";
                                                pmtger.mt_dispstr(LParamLo, msg);
                                                Thread.Sleep(300);
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                        }
                                        break;
                                    /***LOCAL***/
                                    case 3:
                                        //Consulta do LOCAL (Mesa, etc.) do pedido
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            passo[LParamLo]++;
                                            TimerPasso(LParamLo);
                                            PedidoG[LParamLo].Local = "";
                                            palavra[LParamLo] = "";
                                        }
                                        else
                                        {
                                            passo[LParamLo]++;
                                            TimerPasso(LParamLo);
                                            PedidoG[LParamLo].Local = palavra[LParamLo];
                                            palavra[LParamLo] = "";
                                        }
                                        break;
                                    /***GUIA***/
                                    case 4:
                                        //Consulta da Guia (?)
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            passo[LParamLo]++;
                                            TimerPasso(LParamLo);
                                            PedidoG[LParamLo].Guia.CodGuia = 0;
                                            PedidoG[LParamLo].Guia.NomeGuia = "";
                                        }
                                        else if (LancamentoGuia(palavra[LParamLo], LParamLo, strbanco) == 1)
                                        {
                                            passo[LParamLo]++;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        else
                                        {
                                            //Caso não tenha uma guia valida envia GUIA INVALIDA!!!
                                            pmtger.mt_formfeed(LParamLo);
                                            msg = "     GUIA";
                                            pmtger.mt_dispstr(LParamLo, msg);
                                            Thread.Sleep(100);

                                            pmtger.mt_linefeed(LParamLo);
                                            pmtger.mt_carret(LParamLo);

                                            msg = "  INVALIDA!!!";
                                            pmtger.mt_dispstr(LParamLo, msg);
                                            Thread.Sleep(200);
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        break;
                                    /***PRODUTOS***/
                                    case 5:

                                        /** Variaveis **/
                                        string[] print = new string[256];
                                        DateTime datatual = DateTime.Now;
                                        float price;
                                        string sprice;
                                        int tam, i;
                                        byte[] a = new byte[256];
                                       // int auxi;

                                        price = 0;
                                        a[0] = 10;


                                        // Primeiramente verifica se o pedido esta sendo finalizado
                                        // Caso o produto esteja em branco, este indoca que o pedido foi finalizado
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            j = 0;
                                            // Finalização dos pedidos...
                                            // Se houver pedidos estes são inclusos na lista e finalizado.
                                            if (NumeroProd[LParamLo] != 1)
                                            {
                                                // Aqui é incluso o cabeçalho do que será impresso com uma pequena 
                                                // inicialização, data e hora do pedido.

                                                // Print - variavel para futura impressão.

                                                print[j] = ("****** Sistema de Restaurante Gertec ******");
                                                // O contador "j" será equivalente a linha atual da variavel "print". 
                                                j++; //Incluimos a proxima linha 
                                                print[j] = ("Data e Horario: " + datatual.ToString("dd/MM/yyyy hh:mm:ss"));
                                                listBox1.Items.Add(print[j]);
                                                j++;

                                                //Inclui o pedido na lista e no buffer de impressao (print[])
                                                print[j] = (PedidoG[LParamLo].CodUsuario.ToString() + " - " + (PedidoG[LParamLo].Usuario));
                                                listBox1.Items.Add(print[j]);
                                                j++;
                                                print[j] = ("Cartao - " + (PedidoG[LParamLo].Card.codCartao.ToString()));
                                                listBox1.Items.Add(print[j]);
                                                j++;
                                                print[j] = ("Local - " + PedidoG[LParamLo].Local);
                                                listBox1.Items.Add(print[j]);
                                                j++;
                                                print[j] = ("Guia - " + PedidoG[LParamLo].Guia.CodGuia.ToString() + " - " + PedidoG[LParamLo].Guia.NomeGuia);
                                                listBox1.Items.Add(print[j]);
                                                j++;

                                                for (i = 1; i <= NumeroProd[LParamLo] - 1; i++)
                                                {
                                                    print[j] = (PedidoG[LParamLo].Cesta[i].CodProduto.ToString() + " - " + PedidoG[LParamLo].Cesta[i].DescricaoProduto + " x " + PedidoG[LParamLo].Cesta[i].Quantidade.ToString());
                                                    listBox1.Items.Add(print[j]);
                                                    j++;
                                                    if (PedidoG[LParamLo].Cesta[i].Obs.Length > 0)
                                                    {
                                                        print[j] = ("      (" + PedidoG[LParamLo].Cesta[i].Obs + ")");
                                                        listBox1.Items.Add(print[j]);
                                                        j++;
                                                        PedidoG[LParamLo].Cesta[i].Obs = "";
                                                    }
                                                    //--------> Inclui o formato moeda

                                                    sprice = (PedidoG[LParamLo].Cesta[i].Valor).ToString("C");
                                                    print[j] = ("Valor Unit: " + sprice);
                                                    float fprice = (PedidoG[LParamLo].Cesta[i].Valor * PedidoG[LParamLo].Cesta[i].Quantidade);
                                                    sprice = (fprice).ToString("C");
                                                    print[j] += (" .......Total: " + sprice);
                                                    listBox1.Items.Add(print[j]);
                                                    j++;
                                                    // Verifica o total dos pedidos
                                                    PedidoG[LParamLo].TotalCartao += (PedidoG[LParamLo].Cesta[i].Valor * PedidoG[LParamLo].Cesta[i].Quantidade);
                                                    price += (float)(PedidoG[LParamLo].Cesta[i].Valor * PedidoG[LParamLo].Cesta[i].Quantidade);

                                                }
                                                sprice = (price).ToString("C");
                                                print[j] = "Total: " + sprice;
                                                listBox1.Items.Add(print[j]);
                                                j++;
                                                print[j] = (" - - - - - - - - - - - - - - - - - - - - - - - - ");
                                                listBox1.Items.Add(print[j]);

                                                //Efetua a gravação do cartão
                                                if (LancamentoGravarDados(PedidoG[LParamLo].Card.codCartao, strbanco) == 1)
                                                {
                                                    pmtger.mt_formfeed(LParamLo);
                                                    msg = "   LANCAMENTO";
                                                    pmtger.mt_dispstr(LParamLo, msg);

                                                    pmtger.mt_linefeed(LParamLo);
                                                    pmtger.mt_carret(LParamLo);
                                                    msg = "   EFETUADO!!!";
                                                    pmtger.mt_dispstr(LParamLo, msg);

                                                    Thread.Sleep(200);

                                                    passo[LParamLo] = 2;     //volta para Cartão:
                                                    TimerPasso(LParamLo);
                                                    palavra[LParamLo] = "";
                                                }
                                                else
                                                {
                                                    //Caso ocorrer falha na gravação, esta é informada no display e finaliza o pedido
                                                    pmtger.mt_formfeed(LParamLo);
                                                    msg = "   LANCAMENTO";
                                                    pmtger.mt_dispstr(LParamLo, msg);

                                                    pmtger.mt_linefeed(LParamLo);

                                                    pmtger.mt_carret(LParamLo);
                                                    msg = " SEM GRAVACAO!!!";
                                                    pmtger.mt_dispstr(LParamLo, msg);

                                                    Thread.Sleep(200);

                                                    passo[LParamLo] = 2;     //volta para Cartão:
                                                    TimerPasso(LParamLo);
                                                    palavra[LParamLo] = "";
                                                }//Finalização finalizada!!!

                                                /********************************************************
                                                *                 ROTINA PARA IMPRESSÃO                 *
                                                *********************************************************/
                                                //Se o botão imprimir estiver ativo segue a rotina
                                                if (OpImp.Checked == true)
                                                {
                                                    //Verifica a porta indicada a impressora
                                                    if (txComImp.Text == "")
                                                    {
                                                        porta = 0;
                                                    }
                                                    else
                                                    {
                                                        porta = (byte)(int.Parse(txComImp.Text) - 1);
                                                        pmtger.mt_setenableserial(LParamLo, porta, 1);//Habilita a serial
                                                        for (k = 0; k <= j; k++)
                                                        {
                                                            //Se tiver mais de 256 caracteres a string deve ser dividida
                                                            //pois acima de 256 irá travar
                                                            tam = print[k].Length;
                                                            if (tam > 256)
                                                            {
                                                            //**continua:
                                                            continua:
                                                                foreach (byte Buf in buf) buf = null; // Zera o buffer
                                                                if (k < tam)
                                                                {

                                                                    foreach (byte Buf in buf) buf = null; // Zera o buffer
                                                                    //Inclui a informação a ser impressa no Buffer
                                                                    buf = new ASCIIEncoding().GetBytes(print[k]);
                                                                }
                                                                //Imprime
                                                                pmtger.mt_sendbinserial(LParamLo, porta, buf, 255);
                                                                Thread.Sleep(100); // Tempo de ociosidade do microterminal
                                                                k = k + 255; // aumenta no contador a quantidade de caracter já impresso (256)
                                                                tam = tam - 256;//Diminui do tamanho os 256 caracteres já impresso
                                                                //Verifica novamente se o buffer é maior que 256
                                                                if ((k < tam) && (tam > 256))
                                                                {
                                                                    goto continua;
                                                                }
                                                                else
                                                                {
                                                                    foreach (byte Buf in buf) buf = null; // Zera o buffer
                                                                    buf[0] = (byte)(int.Parse(print[k][0].ToString().Substring(k, 255)));
                                                                    pmtger.mt_sendbinserial(LParamLo, porta, buf, 255);
                                                                    Thread.Sleep(100);
                                                                    //Se finalizou pula uma linha para descarregar o buffer
                                                                    pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                                }
                                                            }
                                                            else
                                                            {
                                                                // foreach(byte Buf in buf) buf = null; // Zera o buffer
                                                                // Envio de menos de 256 bytes...
                                                                // Armazenamos cada caracter da string no vetor Buffer
                                                                buf = new ASCIIEncoding().GetBytes(print[k]);
                                                                // Enviar para a serial linha por linha...
                                                                pmtger.mt_sendbinserial(LParamLo, porta, buf, (byte)tam);
                                                                Thread.Sleep(100);
                                                                // Pula para a linha de baixo (se a ultima linha enviada não possuir tamanho suficiente para
                                                                // preencher uma linha completa da impressora esta não é impressa, por isso é enviado o comando
                                                                // abaixo para pular para linha debaixo descarregando o que há no buffer)
                                                                pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                            }
                                                        }
                                                        //Insere espaços para subir o papel na impressora
                                                        pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                        Thread.Sleep(100);
                                                        pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                        Thread.Sleep(100);
                                                        pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                        Thread.Sleep(100);
                                                        pmtger.mt_sendbinserial(LParamLo, porta, a, 2);
                                                        Thread.Sleep(100);
                                                    }
                                                }

                                                /*************************************************************
                                                *           Fim da Rotina de Impressao                       *
                                                **************************************************************/

                                                // Se NumeroProd estiver vazio o pedido não é finalizado e a tela permanece aguardando
                                                // a inclusão de um produto
                                            }
                                            else
                                            {
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                        }
                                        else
                                        {
                                            //Caso não seja finalização dos pedidos efetua a consulta do código digitado
                                            if (LancamentoProduto(palavra[LParamLo], NumeroProd[LParamLo], LParamLo, strbanco) == 1)
                                            {
                                                passo[LParamLo]++;
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                            else
                                            {
                                                TimerPasso(LParamLo);
                                                palavra[LParamLo] = "";
                                            }
                                        }
                                        break;

                                    /*PRODUTO: Inclusão da quantidade no banco*/
                                    case 6:
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            passo[LParamLo]++;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        else if (LancamentoProdutoCesta(float.Parse(palavra[LParamLo]), NumeroProd[LParamLo], LParamLo) == 1)
                                        {
                                            NumeroProd[LParamLo]++;
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }

                                        break;

                                    /****OBSERVAÇÃO****/
                                    case 7:
                                        if (palavra[LParamLo].Length == 0)
                                        {
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                            // Se a observação existir efetua mostra no display e inclui no pedido
                                        }
                                        else if (LancamentoObservacao(int.Parse(palavra[LParamLo]), NumeroProd[LParamLo], LParamLo, strbanco) == 1)
                                        {
                                            pmtger.mt_linefeed(LParamLo);
                                            pmtger.mt_carret(LParamLo);
                                            msg = PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Observ;
                                            pmtger.mt_dispstr(LParamLo, msg);
                                            passo[LParamLo]++;
                                            palavra[LParamLo] = "";
                                        }
                                        else
                                        {
                                            //Se a observação não existir limpa a string palavra
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        break;

                                    /****OBSERVAÇÃO****/
                                    case 8:
                                        string Observa;
                                        if (PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Obs.Length == 0)
                                        {
                                            PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Obs = PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Observ;
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        else
                                        {
                                            Observa = PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Obs + "+" + PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Observ;
                                            PedidoG[LParamLo].Cesta[NumeroProd[LParamLo]].Obs = Observa;
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            palavra[LParamLo] = "";
                                        }
                                        break;
                                }


                            /*********************************************************
						    *  Se a tecla for ESC segue o seguinte procedimento      *
						    **********************************************************/
						    // Caso seja pressionado a tecla ESC retorna para o menu anterior 
						    // "cancelando" o que foi escolhido.
                            }
                            else if (buf[0] == 27)
                            {
                                //Anula o peso
                                peso[LParamLo] = 0;
                                recSerial[0] = 0;
                                TimerPasso(LParamLo);
                                palavra[LParamLo] = "";
                                // Verifica se o pedido será cancelado
                                if (cancela == 1)
                                {
                                    TimerPasso(LParamLo);
                                    cancela = 0;
                                }
                                else
                                {
                                    switch (passo[LParamLo])
                                    {
                                        // Abaixo é subtraido um passo, indicando que deve retornar ao passo anterior
                                        // mostrando a tela anterior ou a mesma tela porem limpa.
                                        case 1:
                                            TimerPasso(LParamLo);
                                            break;
                                        case 2:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 3:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 4:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 5:
                                            //Confirmar cancelamento do pedido
                                            if (NumeroProd[LParamLo] != 1)
                                            {
                                                pmtger.mt_formfeed(LParamLo);
                                                msg = "ENTER-Cancela Pedido";
                                                pmtger.mt_dispstr(LParamLo, msg);

                                                pmtger.mt_linefeed(LParamLo);
                                                pmtger.mt_carret(LParamLo);
                                                msg = "ESC  - Voltar";
                                                pmtger.mt_dispstr(LParamLo, msg);

                                                Thread.Sleep(200);
                                                cancela = 1;
                                            }
                                            else
                                            {
                                                passo[LParamLo]--;
                                                TimerPasso(LParamLo);
                                            }
                                            break;
                                        case 6:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 7:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 8:
                                            passo[LParamLo]--;
                                            TimerPasso(LParamLo);
                                            break;
                                        case 20:
                                            passo[LParamLo] = 21;
                                            TimerPasso(LParamLo);
                                            break;
                                    }
                                }
                            }			
                        }

                    }
                    else
                    {
                        buf2 = "Falha no recebimento!!!";
                        pmtger.mt_dispstr(LParamLo, buf2);
                    }
                }
               
            }
            //recebe mensagens quando um terminal conectou/desconectou
            else if (m.Msg == CONNECT_MSG)
            {

               string addr;
               addr = "";
               conta++;
               addr = pmtger.mt_ipfromid(conta);
               if (addr != null)
               {
                    //Recebe o IP do terminal e adiciona na lista de terminais conectados
                    VConectados.Items.Add(addr);
               }
               else
               {
                    conta--;
               }

            }
            // forward message to base WndProc
            base.WndProc(ref m);
        }

        /********************************************************************************************************
        * Função: btImprimir																    				*
        *********************************************************************************************************
        *																										*
        * Data de Criação: 26/09/2008																			*
        *																										*
        * Retorno: BYTE																							*
        *																										*	
        * Descrição: Responsável pela impressão dos produtos							        				*	
        *																										*
        *********************************************************************************************************/
        private void btImprimi_Click(object sender, EventArgs e)
        {
            byte com, tamBuf;
            byte[]a = new byte[256];
		    byte[] buffer = new byte [256];
		    int i, tam, k;
            int terminal;

            i = 0;
		    //Verifica se há um microterminal selecionado e se a porta da impressão
		    //foi determinada.
            if ((VConectados.SelectedIndex == -1) || (txComImp.Text == ""))
            {
                MessageBox.Show("Selecione o terminal e/ou a porta", "Atenção!");

            }
            else
            {
                terminal = int.Parse(VConectados.SelectedIndex.ToString());  
                com = (byte)(int.Parse(txComImp.Text) - 1);
                a[0] = 10; // Valor correspondente ao próxima linha da impressora
                // Habilita a serial
                pmtger.mt_setenableserial(terminal + 1, com, 1);

                for (k = 0; (k <= (listBox1.Items.Count - 1)); k++)
                {
                    // Verifica o tamanho de cada linha da lista que será impressa. 
                    // Caso seja maior que 256 caracteres esta deve ser tratada para enviar 
                    // a cada 256, acima disso ocorrerá erro.
                    try
                    {
                        tam = listBox1.Items[k].ToString().Length;
                        if (tam > 256)
                        {
                        continua:
                            foreach (byte Buf in buffer) buffer = null; // Zera o buffer
                            if (i < tam)
                            {
                                foreach (byte Buf in buffer) buffer = null; // Zera o buffer
                                //Inclui a informação a ser impressa no Buffer
                                buffer = new ASCIIEncoding().GetBytes(listBox1.Items[k].ToString().Substring(i, 255));
                            }
                            //Imprime
                            pmtger.mt_sendbinserial((terminal + 1), com, buffer, 255);
                            Thread.Sleep(100); // Tempo de ociosidade do microterminal
                            i = i + 255; // aumenta no contador a quantidade de caracter já impresso (256)
                            tam = tam - 256;//Diminui do tamanho os 256 caracteres já impresso
                            //Verifica novamente se o buffer é maior que 256
                            if ((i < tam) && (tam > 256))
                            {
                                goto continua;
                            }
                            else
                            {
                                foreach (byte Buf in buffer) buffer = null; // Zera o buffer
                                buffer = new ASCIIEncoding().GetBytes(listBox1.Items[k].ToString().Substring(i, tam));
                                pmtger.mt_sendbinserial((terminal + 1), com, buffer, 255);
                                Thread.Sleep(100);
                                //Se finalizou pula uma linha para descarregar o buffer
                                pmtger.mt_sendbinserial((terminal + 1), com, a, 2);
                            }
                        }
                        else
                        {
                            foreach (byte Buf in buffer) buffer = null; // Zera o buffer
                            // Envio de menos de 256 bytes...
                            // Armazenamos cada caracter da string no vetor Buffer
                            buffer = new ASCIIEncoding().GetBytes(listBox1.Items[k].ToString());
                            // Enviar para a serial linha por linha...
                            
                            tamBuf = (byte)tam;
                            pmtger.mt_sendbinserial(terminal + 1, com, buffer, tamBuf);
                            Thread.Sleep(100);
                            // Pula para a linha de baixo (se a ultima linha enviada não possuir tamanho suficiente para
                            // preencher uma linha completa da impressora esta não é impressa, por isso é enviado o comando
                            // abaixo para pular para linha debaixo descarregando o que há no buffer)
                            pmtger.mt_sendbinserial(terminal + 1, com, a, 2);
                        }

                    }
                    catch
                    {
                        MessageBox.Show("Falha no envio!", "Erro");
                        break;
                    }

                }
                // Inclui 4 linhas de espaço para subir o papel da impressora e incluir um espaço entre esta e 
                // a proxima impressão. Sempre inclui um tempo de 100ms para não encavalar as informações
                pmtger.mt_sendbinserial(terminal + 1, com, a, 2);
                Thread.Sleep(100);
                pmtger.mt_sendbinserial(terminal + 1, com,  a, 2);
                Thread.Sleep(100);
                pmtger.mt_sendbinserial(terminal + 1, com, a, 2);
                Thread.Sleep(100);
                pmtger.mt_sendbinserial(terminal + 1, com, a, 2);
                Thread.Sleep(100);
            }
        

            
        }

        /********************************************************************************************************
        * Função: LancamentoUsuario																				*
        *********************************************************************************************************
        *																										*
        * Data de Criação: 16/09/2008																			*
        *																										*
        * Retorno: BYTE																							*
        *																										*	
        * Descrição: Responsável pela consulta na tabela tabUsuario												*	
        *																										*
        *********************************************************************************************************/
        public byte LancamentoUsuario(string CodUsuario, int id, string strbd)
        {
            string strselect;
            drok = 0;
            
            try
            {
                
                //Armazena a select a ser consultada
                strselect = ("SELECT usuID,usuNome,funID,usuLogin FROM tabUsuario WHERE usuID = " + CodUsuario);
                OleDbConnection con = new OleDbConnection(strbd);
                OleDbCommand cmd = new OleDbCommand(strselect, con);
                
                con.Open();
                cmd.CommandType = CommandType.Text;
                OleDbDataReader dr = cmd.ExecuteReader();

                //Verifica se há informações encontradas e as armazena para utilização futura
                while (dr.Read())
                {
                    PedidoG[id].CodUsuario = dr.GetInt32(dr.GetOrdinal("usuID"));
                    PedidoG[id].Usuario = dr.GetString(dr.GetOrdinal("usuNome"));
                    PedidoG[id].FuncaoID = dr.GetInt32(dr.GetOrdinal("funID"));
                    if ((PedidoG[id].FuncaoID == 5) || (PedidoG[id].FuncaoID == 6)) drok = 1;
                }
                if (drok == 1)
                {
                    dr.Close();
                    con.Close();
                    return 1;
                }
                else
                {

                    dr.Close();
                    con.Close();
                    return 0;
                }
            }
            catch
            {
                return 0;
            }
        }


        /********************************************************************************************************
        * Função: LancamentoCartao														            			*
        *********************************************************************************************************
        *																										*
        * Data de Criação: 16/09/2008																			*
        *																										*
        * Retorno: BYTE																							*
        *																										*	
        * Descrição: Responsável pela consulta na tabela tabCartao												*	
        *																										*
        *********************************************************************************************************/
        public byte LancamentoCartao(string CodCartao, int id, string strbd)
        {
            string strcard;
            try
            {
                //Armazena a select a ser consultada
                strcard = ("SELECT carId, carStatus, carIngresso, carConsumacao, carDesconto, carTxServico" +
                    " FROM tabCartao WHERE carId = " + (CodCartao) + ";");
                //Cria a conexão com o banco de dados
                OleDbConnection con = new OleDbConnection(strbd);
                // Aqui é criado um objeto para executar o select
                OleDbCommand cmd = new OleDbCommand(strcard, con);
                //Abre o banco de dados 
                con.Open();
                //Define o tipo do comando
                cmd.CommandType = CommandType.Text;

                OleDbDataReader dr = cmd.ExecuteReader();

                while (dr.Read())
                {
                    if (dr.GetString(1) != "")
                    {
                        //Recebe o codigo do cartão, seu status, taxa de consumação e serviço
                        PedidoG[id].Card.codCartao = dr.GetInt32(dr.GetOrdinal("carId"));
                        PedidoG[id].Card.StatusCartao = dr.GetString(dr.GetOrdinal("carStatus"));
                        PedidoG[id].Card.txConsumacao = (int)dr.GetDouble(dr.GetOrdinal("carConsumacao"));
                        PedidoG[id].Card.txServico = (int)dr.GetDouble(dr.GetOrdinal("carTxServico"));
                    }

                }
                if ((PedidoG[id].Card.StatusCartao == "U") || (PedidoG[id].Card.StatusCartao == "D"))
                {
                    dr.Close();
                    con.Close();
                    return (1);
                }
                else
                {
                    dr.Close();
                    con.Close();
                    return (0);
                }
            }
            catch
            {
                return 0;
            }
        }

        /********************************************************************************************************
	    * Função: LancamentoGuia														            			*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 16/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pela consulta da guia na tabela tabUsuario										*	
	    *																										*
	    *********************************************************************************************************/
        public byte LancamentoGuia(string CodGuia, int id, string strbd)
        {
            string strguia;
            drok = 0;
            try
            {
                //Armazena a select a ser consultada
                strguia = ("SELECT usuId,usuNome FROM TabUsuario WHERE usuId = " + (CodGuia) + " AND funId = 4");
                OleDbConnection con = new OleDbConnection(strbd);
                OleDbCommand cmd = new OleDbCommand(strguia, con);

                con.Open();
                cmd.CommandType = CommandType.Text;
                OleDbDataReader dr = cmd.ExecuteReader();

                while (dr.Read())
                {
                    PedidoG[id].Guia.CodGuia = dr.GetInt32(dr.GetOrdinal("usuId"));
                    PedidoG[id].Guia.NomeGuia = dr.GetString(dr.GetOrdinal("usuNome"));
                    drok = 1;
                }

                if (drok == 1)
                {
                    dr.Close();
                    con.Close();
                    return 1;
                }
                else
                {
                    dr.Close();
                    con.Close();
                    return 0;
                }

            }
            catch
            {
                return 0;
            }
        }

        /********************************************************************************************************
	    * Função: LancamentoGravarDados																			*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 17/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pela gravação dos dados do cartão												*	
	    *																										*
	    *********************************************************************************************************/
        public byte LancamentoGravarDados(int Cartao, string strbd)
        {
            string strgravad;
            drok = 0;
            try
            {
                //Armazena a select a ser consultada
                strgravad = ("SELECT mheId From TabHeaderMovimento where carId = " + Cartao.ToString() + " And mheStatus = '1'");
                OleDbConnection con = new OleDbConnection(strbd);
                OleDbCommand cmd = new OleDbCommand(strgravad, con);

                con.Open();
                cmd.CommandType = CommandType.Text;
                OleDbDataReader dr = cmd.ExecuteReader();

                //Verifica se há arquivos para leitura, ou seja, se foi encontrado algum arquivo com
                //o numero enviado e status 1
                while (dr.Read())
                {
                    //Se foi encontrado drok recebe 1 indicando que houve leitura
                    drok = 1;
                }
                //Se houve leitura return = 1, senão return = 0
                if (drok == 1)
                {
                    dr.Close();
                    con.Close();
                    return 1;
                }
                else
                {
                    dr.Close();
                    con.Close();
                    return 0;
                }
               
            }
            catch
            {
                return 0;
            }
        }
        /********************************************************************************************************
	    * Função: LancamentoProduto																				*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 17/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pela consulta dos produtos na tabela tab		    							*	
	    *																										*
	    *********************************************************************************************************/
        public byte LancamentoProduto(string Produto, int NumeroProdutos, int id, string strbd)
        {
            string strguia;
            drok = 0;
            try
            {
                //Armazena a select a ser consultada
                strguia = ("SELECT proId,proDescricao,proPreco FROM tabProduto WHERE proId = " + Produto);
                OleDbConnection con = new OleDbConnection(strbd);
                OleDbCommand cmd = new OleDbCommand(strguia, con);

                con.Open();
                cmd.CommandType = CommandType.Text;
                OleDbDataReader dr = cmd.ExecuteReader();

                //Verifica se há arquivos para ler e os armazena para uso futuro
                while (dr.Read())
                {
                    PedidoG[id].Cesta[NumeroProdutos].CodProduto = dr.GetInt32(dr.GetOrdinal("proID"));
                    PedidoG[id].Cesta[NumeroProdutos].DescricaoProduto = dr.GetString(dr.GetOrdinal("proDescricao"));
                    PedidoG[id].Cesta[NumeroProdutos].Valor = (float)dr.GetDouble(dr.GetOrdinal("proPreco"));
                    drok = 1;
                }
                if (drok == 1)
                {
                    dr.Close();
                    con.Close();
                    return 1;
                }
                else
                {
                    dr.Close();
                    con.Close();
                    return 0;
                }
            }
            catch
            {
                return 0;
            }

        }
        /********************************************************************************************************
	    * Função: LancamentoProdutoCesta																		*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 17/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pelo lançamento dos produtos ao pedido 										*	
	    *																										*
	    *********************************************************************************************************/
        public byte LancamentoProdutoCesta(float Quantidade, int NumeroProduto, int id)
        {
            try
            {
                //Verifica a quantidade
                if (Quantidade != 0)
                {
                    PedidoG[id].Cesta[NumeroProduto].Quantidade = Quantidade;
                    return (1);
                }
                else
                {
                    return (0);
                }
            }
            catch
            {
                return 0;
            }
        }
        /********************************************************************************************************
	    * Função: LancamentoObservacao																			*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 17/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pela consulta das opções existentes para os produtos. Ex: mal passado.			*	
	    *																										*
	    *********************************************************************************************************/
        public byte LancamentoObservacao(int CodObs, int NumeroProdutos, int id, string strbd)
        {
            string strobs;
            drok = 0;
            try
            {
                //Armazena a select a ser consultada
                strobs = ("SELECT * FROM tabObs WHERE obsId = " + CodObs.ToString());
                OleDbConnection con = new OleDbConnection(strbd);
                OleDbCommand cmd = new OleDbCommand(strobs, con);

                con.Open();
                cmd.CommandType = CommandType.Text;
                OleDbDataReader dr = cmd.ExecuteReader();

                while (dr.Read())
                {
                    PedidoG[id].Cesta[NumeroProdutos].Observ = dr.GetString(dr.GetOrdinal("obsDescricao"));
                    drok = 1;
                }
                if (drok == 1)
                {
                    dr.Close();
                    con.Close();
                    return 1;
                }
                else
                {
                    dr.Close();
                    con.Close();
                    return 0;
                }
            }
            catch
            {
                return 0;
            }
        }

        /********************************************************************************************************
	    * Função: bt_Gravar																			            *
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 19/09/2008																			*
	    *																										*
	    * Retorno: void																							*
	    *																										*	
	    * Descrição: Responsável pela consulta nos campos (texts) refrente ao banco de dados e gravação         *
        * no setting (ArqBanco).		                                                                        *	
	    *																										*
	    *********************************************************************************************************/
        private void btGravar_Click(object sender, EventArgs e)
        {
             //Grava os dados que se encontram nos textbox para o Settings.
            if (bdAccess.Checked == true) Properties.ArqBanco.Default.bdbanco = 2;
            else Properties.ArqBanco.Default.bdbanco = 1;

            Properties.ArqBanco.Default.sqlServidor = txServidor.Text.ToString().Trim();
		    Properties.ArqBanco.Default.sqlBanco = txBanco.Text.ToString().Trim();
		    Properties.ArqBanco.Default.sqlUser = txUser.Text.ToString().Trim();
            Properties.ArqBanco.Default.sqlPass = txPass.Text.ToString().Trim();

            Properties.ArqBanco.Default.mdbBanco = txBancoAc.Text.ToString().Trim();
            Properties.ArqBanco.Default.mdbCaminho = txWay.Text.ToString().Trim();

            Properties.ArqBanco.Default.Save();	
            
        }
        
   
                 
        /********************************************************************************************************
	    * Função: bdSql																							*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação dos campos referente ao banco de dados						*	
	    *																										*
	    *********************************************************************************************************/
    	private void bdSql_CheckedChanged(object sender, EventArgs e)
        {
            if (bdSql.Checked == true)
            {
                label1.Enabled = true;
                label2.Enabled = true;
                label3.Enabled = true;
                label4.Enabled = true;
                label5.Enabled = true;
                txServidor.Enabled = true;
                txBanco.Enabled = true;
                txUser.Enabled = true;
                txPass.Enabled = true;

                label6.Enabled = false;
                label5.Enabled = false;
                txBancoAc.Enabled = false;
                txWay.Enabled = false;

                //Retira os espaços em branco dos campos
                txServidor.Text = txServidor.Text.ToString().Trim();
                txBanco.Text = txBanco.Text.ToString().Trim();
                //Verifica se o campo está vazio
                if ((txServidor.Text.ToString() == "") || (txBanco.Text.ToString() == ""))
                {
                    btIniciar.Enabled = false;
                }
                else
                {
                    btIniciar.Enabled = true;
                }
            }

        }
        /********************************************************************************************************
	    * Função: bdAccess																						*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação dos campos referente ao banco de dados 						*	
	    *																										*
	    *********************************************************************************************************/
        private void bdAccess_CheckedChanged(object sender, EventArgs e)
        {
            if (bdAccess.Checked == true)
            {
                label1.Enabled = false;
                label2.Enabled = false;
                label3.Enabled = false;
                label4.Enabled = false;
                label5.Enabled = false;
                txServidor.Enabled = false;
                txBanco.Enabled = false;
                txUser.Enabled = false;
                txPass.Enabled = false;

                label6.Enabled = true;
                label5.Enabled = true;
                txBancoAc.Enabled = true;
                txWay.Enabled = true;
                //Retira os epaços em branco dos campos
                txBancoAc.Text = txBancoAc.Text.ToString().Trim();
                txWay.Text = txWay.Text.ToString().Trim();

                //Verifica se o campo está vazio
                if ((txBancoAc.Text.ToString() == "") ||(txWay.Text.ToString() == ""))
                {
                    btIniciar.Enabled = false;
                }
                else
                {
                    btIniciar.Enabled = true;
                }
            }
        }

        /********************************************************************************************************
	    * Função: txBancoAc																				        *
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: BYTE																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação do menu Iniciar												*	
	    *																										*
	    *********************************************************************************************************/
        private void txBancoAc_TextChanged(object sender, EventArgs e)
        {
            //Retira os espaços em branco do text
            txBancoAc.Text = txBancoAc.Text.ToString().Trim();
            //Verifica se os campos obrmigatorios para identificar o banco de dados esta preenchido
            //Caso esteja o menu Inicicar fica habilitado
            if ((txBancoAc.Text.ToString() == "") || (txWay.Text.ToString() == ""))
            {
                btIniciar.Enabled = false;
            }
            else
            {
                btIniciar.Enabled = true;
            }
        }

        /********************************************************************************************************
	    * Função: txWay																							*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação do menu Iniciar												*	
	    *																										*
	    *********************************************************************************************************/
        private void txWay_TextChanged(object sender, EventArgs e)
        {
            //Retira os espaços em branco do text
            txWay.Text = txWay.Text.ToString().TrimStart();
            //Verifica se os campos obrmigatorios para identificar o banco de dados esta preenchido
            //Caso esteja o menu Inicicar fica habilitado
            if ((txBancoAc.Text.ToString() == "") || (txWay.Text.ToString() == ""))
            {
                btIniciar.Enabled = false;
            }
            else
            {
                btIniciar.Enabled = true;
            }
        }

        /********************************************************************************************************
	    * Função: txServidor																					*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação do menu iniciar												*	
	    *																										*
	    *********************************************************************************************************/
    	private void txServidor_TextChanged(object sender, EventArgs e)
        {
            //Retira os espaços em branco do text
            txServidor.Text = txServidor.Text.ToString().Trim();
            //Verifica se os campos obrmigatorios para identificar o banco de dados esta preenchido
            //Caso esteja o menu Inicicar fica habilitado
            if ((txServidor.Text.ToString() == "") || (txBanco.Text.ToString() == ""))
            {
                btIniciar.Enabled = false;
            }
            else
            {
                btIniciar.Enabled = true;
            }
        }

        /********************************************************************************************************
	    * Função: txBanco																						*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Responsável pela habilitação do menu Iniciar												*	
	    *																										*
	    *********************************************************************************************************/
        private void txBanco_TextChanged(object sender, EventArgs e)
        {
            //Retira os espaços em branco
            txBanco.Text = txBanco.Text.ToString().Trim();
            //Verifica se os campos obrmigatorios para identificar o banco de dados esta preenchido
            //Caso esteja o menu Inicicar fica habilitado
            if ((txServidor.Text.ToString() == "") || (txBanco.Text.ToString() == ""))
            {
                btIniciar.Enabled = false;
            }
            else
            {
                btIniciar.Enabled = true;
            }
        }
        /********************************************************************************************************
	    * Função: 	btSair																		                *
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 24/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Menu Sair - responsável pela saida do programa e fechamento da DLL.						*	
	    *																										*
	    *********************************************************************************************************/
        private void btSair_Click(object sender, EventArgs e)
        {
            if (btIniciar.Text == "Terminar")
            {
                pmtger.mt_finishserver();
            }
            Close();
        }

        /************************************************************************
         ************************Config. Serial**********************************
         ************************************************************************/

       /* private void btRecebeConfSerial_Click(object sender, EventArgs e)
        {
            byte com;
            if ((VConectados.SelectedIndex == -1) || (cbPorta.SelectedIndex == -1))
            {
                MessageBox.Show("Selecione o terminal e/ou a porta", "Atenção");
            }
            else
            {
                com = (byte)cbPorta.SelectedIndex;
                if (pmtger.mt_reqconfigserial(VConectados.SelectedIndex + 1, com) < 1)
                {
                    MessageBox.Show("Erro no envio do comando", "FALHA");
                }
            }
        }*/

        /********************************************************************************************************
	    * Função: 	btEnviaConfSerial																			*
	    *********************************************************************************************************
	    *																										*
	    * Data de Criação: 19/09/2008																			*
	    *																										*
	    * Retorno: Void																							*
	    *																										*	
	    * Descrição: Envia a configuração serial para o terminal 												*	
	    *																										*
	    *********************************************************************************************************/
     /*   private void btEnviaConfSerial_Click(object sender, EventArgs e)
        {

            structs.TSetupSerial config = new structs.TSetupSerial();
            structs.Arg_Com_SetupSerial configuracao = new structs.Arg_Com_SetupSerial();

            try
            {
                if ((VConectados.SelectedIndex == -1) || (cbPorta.SelectedIndex == -1))
                {
                    MessageBox.Show("Selecione o terminal e/ou a porta", "Atenção!");

                }
                else
                {

                    // Recebendo toda configuração da serial    				
                    config.baud = int.Parse(cbBaud.Text);
                    config.bits = short.Parse(cbBits.Text);

                    if (cbParidade.Text == "Nenhum")
                    {
                        config.parity = 0;
                    }
                    else if (cbParidade.Text == "Impar")
                    {
                        config.parity = 1;
                    }
                    else if (cbParidade.Text == "Par")
                    {
                        config.parity = 2;
                    }
                    else if (cbParidade.Text == "Marca")
                    {
                        config.parity = 3;
                    }
                    else if (cbParidade.Text == "Espaço")
                    {
                        config.parity = 4;
                    }
                    config.stops = short.Parse(cbStop.Text);

                    if (cbHand.Text == "Nenhum")
                    {
                        config.handshaking = 0;
                    }
                    else
                    {
                        config.handshaking = 1;
                    }
                    // Selecionando a COM
                    configuracao.Com = (byte)cbPorta.SelectedIndex;
                    configuracao.Setup = config;

                    // Envia configuração para o terminal
                    if (pmtger.mt_sendconfigserial(VConectados.SelectedIndex + 1, ref configuracao) != 1)
                    {
                        MessageBox.Show("Erro enviando comando.", "Falha");
                    }
                    else
                    {
                        //Reinicia o microterminal para que o mesmo assuma a nova configuração
                        pmtger.mt_restart(VConectados.SelectedIndex + 1);
                    }
                }
            }
            catch
            {
                MessageBox.Show("Preencha corretamente os campos.", "Erro");
            }
        }*/

        private void timerVConectados_Tick(object sender, EventArgs e)
        {          
            int j, k;

            k = VConectados.Items.Count ;       
            for (j = 1; j <= k ; j++)
            {
                pmtger.mt_sendlive(j);      
            }                       
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void VConectados_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
       
    }

}