/****************************************************************************
* Aplicativo : SMTGeR... Servidor de Microterminais Gertec - Restaurante    *
* Autor		 : Ana Lcia S. Melo 										    *
* Referncia : SMTGeR - Programa Servidor para Micro Terminais              *
* Data       : 07/07/08													    *
* Ambiente   : Visual C++ 2005 (Express Edition)                            *
* Fonte      : structs.h													*
* Objetivo   : Estrutura para utilizao da DLL								*
* Notas		 : Este fonte destina-se exclusivamente como material de	    *
*			   auxilio a desenvolvedores de aplicaes para produtos Gertec.*
****************************************************************************/

#ifndef STRUCTS_H
#define STRUCTS_H

#pragma pack(push)
#pragma pack(1)

typedef struct {
  unsigned short ID;
  unsigned short TamArg;
} CMDHEADER;

typedef struct {
  unsigned char cod[512];
}ARG_CODE; // Argumento de Codigo

typedef struct {
 unsigned char cArg1;
 unsigned char cArg2;
}ARG_BYTE_BYTE; // Argumento de Funcao (BYTE,BYTE) ou (CHAR,CHAR)

typedef struct {
 unsigned char cArg1;
 unsigned long bArg2;
}ARG_BYTE_BOOL; // Argumento de Funcao (BYTE,BOOL)

typedef struct
{
  unsigned long  baud;       /* 300 a 115.200 bauds; */
  unsigned short  bits;      /* data bits */
  unsigned short  parity;    /* see below */
  unsigned short  stops;     /* stop bits 1 or 2 */
  unsigned char handshaking; /* 0 -> none handshaking  1 -> RTS/CTS */
} TSetupSerial;

typedef struct{
  unsigned long gateway;
  unsigned long nameserver;
  char myname[16];
}TExSetupTCP;

typedef struct {
 unsigned char Com;
 TSetupSerial Setup;
}ARG_COM_SETUPSERIAL;



typedef union {   // Argumento em Geral ocupando o mesmo espaco de memoria
  ARG_CODE             aCode;
  ARG_BYTE_BYTE        aByteByte;
  ARG_BYTE_BOOL        aByteBool;
  ARG_COM_SETUPSERIAL  aSetupSerial;

  unsigned long        Dword;
  unsigned short       Word;
  unsigned char        Byte;
} ARGUMENT;

typedef struct
{
 int TabIP[255];
} TTABSOCK;

#pragma pack(pop)

#endif /*STRUCTS_H*/

