unit cls_ComandosBanco;

interface
uses Windows,Messages, Graphics, SysUtils, StdCtrls, Controls, Forms, DBTables, DB, DBCtrls;

function LancamentoUsuario(CodUsuario: string; id: integer ): Boolean;
function LancamentoCartao(CodCartao: string; id: integer): Boolean;
function LancamentoGuia(CodGuia: string; id: integer): Boolean;
function LancamentoGravarDados(Cartao: string): Boolean;
function LancamentoProduto (Produto: string; NumeroProdutos: integer; id: integer): boolean;
function LancamentoProdutoCesta (Quantidade: real; NumeroProduto: integer; id: integer): boolean;
function LancamentoObservacao (CodObs: Integer; NumeroProduto: integer; id: integer): boolean;

implementation
uses Unit1;

//********************************************************************************************************
// Evento: LancamentoUsusario
//********************************************************************************************************
//
// Data de Criao: 26/05/2008
//
// Descrio: Consulta no banco de dados o cdigo do operador digitado e retorna o nome do mesmo
//
//********************************************************************************************************

function LancamentoUsuario(CodUsuario: string; id: integer): Boolean;
begin

 with FrmPrincipal do begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do operador solicitado
      qrProd.SQL.add('SELECT usuId,usuNome,funID,usuLogin FROM tabUsuario WHERE usuID = ' +  CodUsuario );

      // Qualquer problema que houver ir gerar uma exception de falha na conexo do banco de dados.
      Try
        // Ativa a pesquisa
        qrProd.Active := true;

        // Verifica se foi encontrado algum registro
        IF (qrProd.Fields[0].Value <> null) then begin
           PedidoG[id].CodUsuario := qrProd.FieldValues['usuId'];
           PedidoG[id].Usuario := qrProd.FieldValues['usuNome'];
           PedidoG[id].FuncaoID := qrProd.FieldValues['funID'];

           //A funo 5 e 6 indicam que o operador  garom e pode procedir com o pedido
           if (PedidoG[id].FuncaoID = 5) or (PedidoG[id].FuncaoID = 6) then
              LancamentoUsuario := True
           else LancamentoUsuario := False;

       end else LancamentoUsuario := False;

     except
        LancamentoUsuario := False;
     end; // Try

   end;//with

end;

//********************************************************************************************************
// Evento: LancamentoCartao
//********************************************************************************************************
//
// Data de Criao: 26/05/2008
//
// Descrio: Consulta no banco de dados o status do carto digitado
//
//********************************************************************************************************

function LancamentoCartao(CodCartao: string; id: integer): Boolean;
Begin
   with FrmPrincipal do begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do carto solicitado
      qrProd.SQL.add('SELECT carId, carStatus, carIngresso, carConsumacao, carDesconto, carTxServico ' +
                     'FROM tabCartao ' +
                     'WHERE carId = ' + CodCartao );

      // Qualquer problema que houver ir gerar uma exception de falha na conexo do banco de dados.
      Try
        // Ativa a pesquisa
        qrProd.Active := true;

        // Verifica se foi encontrado algum registro
        IF (qrProd.Fields[0].Value <> null) then begin
           PedidoG[id].Card.codCartao := qrProd.FieldValues ['carId'];
           PedidoG[id].Card.StatusCartao := qrProd.FieldValues['carStatus'];
           PedidoG[id].Card.txConsumacao := qrProd.FieldValues ['carConsumacao'];
           PedidoG[id].Card.txServico := qrProd.FieldValues ['carTxServico'];
           //Verifica o status do cartao
           if (PedidoG[id].Card.StatusCartao = 'D') or (PedidoG[id].Card.StatusCartao = 'U') then
              LancamentoCartao := True
           else LancamentoCartao := False;

        end else LancamentoCartao := False;

      except
        LancamentoCartao := False;
      end; // Try

   end;//with

end;

//********************************************************************************************************
// Evento: LancamentoGuia
//********************************************************************************************************
//
// Data de Criao: 26/05/2008
//
// Descrio: Consulta no banco de dados o cdigo da guia digitado e retorna o nome do mesmo
//
//********************************************************************************************************
function LancamentoGuia(CodGuia: string; id: integer): Boolean;
Begin
   with FrmPrincipal do begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do operador solicitado
      qrProd.SQL.add('SELECT usuId,usuNome FROM TabUsuario WHERE usuId = ' + CodGuia + ' AND funId = 4');

      // Qualquer problema que houver ir gerar uma exception de falha na conexo do banco de dados.
      Try
        // Ativa a pesquisa
        qrProd.Active := true;

        // Verifica se foi encontrado algum registro
        if (qrProd.Fields[0].Value <> null) then begin
           PedidoG[id].Guia.CodGuia := qrProd.FieldValues ['usuId'];
           PedidoG[id].Guia.NomeGuia := qrProd.FieldValues['usuNome'];
           LancamentoGuia := True ;
        end else LancamentoGuia := False;

      except
        LancamentoGuia:= False;
      end; // Try

   end;//with

end;

//********************************************************************************************************
// Evento: LancamentoGravaDados
//********************************************************************************************************
//
// Data de Criao: 27/05/2008
//
// Descrio: Gravao do carto
//
//********************************************************************************************************

function LancamentoGravarDados(Cartao: string): Boolean;
var sqlselect : string;
begin
   with FrmPrincipal do begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do operador solicitado

       sqlselect :=('SELECT  mheId From TabHeaderMovimento where carId = ' + Cartao + ' And mheStatus =  ''1''');
       qrProd.SQL.add (sqlselect);

      // Qualquer problema que houver ir gerar uma exception de falha na conexo do banco de dados.
      Try
         // Ativa a pesquisa
         qrProd.Active := true;
         LancamentoGravarDados:= true;
      except
         LancamentoGravarDados:= False;
      end;
   end;
end;

//********************************************************************************************************
// Evento: LancamentoProduto
//********************************************************************************************************
//
// Data de Criao: 27/05/2008
//
// Descrio: Consulta no banco de dados o cdigo do produto digitado e retorna a descrio e preo do mesmo
//
//********************************************************************************************************

function LancamentoProduto (Produto: string; NumeroProdutos: integer; id: integer): boolean;
var valor : string;
begin
   with FrmPrincipal do Begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do operador solicitado
      qrProd.SQL.add('SELECT proId,proDescricao,proPreco FROM tabProduto WHERE proId = ' + Produto);

      // Qualquer problema que houver ir gerar uma exception de falha na conexo do banco de dados.
      Try
        // Ativa a pesquisa
        qrProd.Active := true;

        // Verifica se foi encontrado algum registro
        if (qrProd.Fields[0].Value <> null) then begin
           PedidoG[id].Cesta[NumeroProdutos].CodProduto := qrProd.FieldValues ['proID'];
           PedidoG[id].Cesta[NumeroProdutos].DescricaoProduto := qrProd.FieldValues['proDescricao'];
           PedidoG[id].Cesta[NumeroProdutos].Valor := qrProd.FieldValues ['proPreco'];
           valor:= qrProd.FieldValues['proDescricao'];
           LancamentoProduto := True ;
        end else LancamentoProduto := False;

      except
        LancamentoProduto:= False;
      end; // Try

   end;//with
end;

//********************************************************************************************************
// Evento: LancamentoProdutoCesta
//********************************************************************************************************
//
// Data de Criao: 28/05/2008
//
// Descrio: Inclui na cesta a quantidade solicitada
//
//********************************************************************************************************
function LancamentoProdutoCesta (Quantidade: real; NumeroProduto: integer; id: integer): boolean;
begin
   with FrmPrincipal do begin
      try
      if Quantidade <> 0 then begin
         PedidoG[id].Cesta[NumeroProduto].Quantidade := Quantidade;
         LancamentoProdutoCesta := True;
      end else LancamentoProdutoCesta := False;
      except
         LancamentoProdutoCesta := False;
      end;   
   end;
end;

//********************************************************************************************************
// Evento: LancamentoObservacao
//********************************************************************************************************
//
// Data de Criao: 28/05/2008
//
// Descrio: Consulta no banco de dados a observao solicitada no pedido
//
//********************************************************************************************************
function LancamentoObservacao (CodObs: Integer; NumeroProduto: integer; id: integer): boolean;
begin
   with FrmPrincipal do Begin
      // Efetua pesquisa usando o Query de Pesquisa qrProd
      qrProd.Active := false;
      qrProd.DatabaseName := cbAlias.Text ;
      qrProd.SQL.clear;
      // Verifica se existe o codigo do operador solicitado
      qrProd.SQL.add('SELECT * FROM tabObs WHERE obsId = ' + IntToStr(CodObs));
      try
      // Ativa a pesquisa
      qrProd.Active := true;

      // Verifica se foi encontrado algum registro
      if (qrProd.Fields[0].Value <> null) then begin
         PedidoG[id].Cesta[NumeroProduto].Observ := qrProd.FieldValues ['obsDescricao'];
         LancamentoObservacao:= True;
       end else LancamentoObservacao:= False;
       except
          LancamentoObservacao:= False;
       end;
   end;

end;

end.
