Attribute VB_Name = "Module1"
'/*********************************************************************************
'Declarao das Variaveis Globais
'**********************************************************************************
'Data de Criao: 23/4/2007
'
'Autor: Flvia C. Montagneri
'**********************************************************************************

'TCP/IP

Public Const vLive              As Integer = (&H1)
Public Const wGetIdentify       As Integer = (&H3)
Public Const vSetSetupTCP       As Integer = (&H5)
Public Const vGetSetupTCP       As Integer = (&H7)
Public Const vSetExSetupTCP     As Integer = (&H51)
Public Const vGetExSetupTCP     As Integer = (&H53)
Public Const vSetExSetupUpdate  As Integer = (&H55)
Public Const vGetSetupUpdate    As Integer = (&H57)
Public Const vRestart           As Integer = (&H59)
Public Const vUpdate            As Integer = (&H5A)
Public Const vFTPMode           As Integer = (&H5B)

'CARD

Public Const vSetCard           As Integer = (&H9)
Public Const bGetCard           As Integer = (&HB)
Public Const bReadBuffCard      As Integer = (&HD)

'TECLADO

Public Const vSetEnableKey      As Integer = (&HF)
Public Const bGetEnableKey      As Integer = (&H11)
Public Const vReset             As Integer = (&H13)
Public Const vSetCapsLock       As Integer = (&H15)
Public Const bGetCapsLock       As Integer = (&H17)
Public Const vSetNumLock        As Integer = (&H19)
Public Const bGetNumLock        As Integer = (&H1B)
Public Const cGetCharTerm       As Integer = (&H1D)
Public Const bProgramKbd        As Integer = (&H1F)
Public Const vSetBeep           As Integer = (&H5D)
Public Const vSetBeepKey        As Integer = (&H5F)

'DISPLAY

Public Const vBackSpace         As Integer = (&H21)
Public Const vCarRet            As Integer = (&H23)
Public Const vLineFeed          As Integer = (&H25)
Public Const vFormFeed          As Integer = (&H27)
Public Const vGoToXY            As Integer = (&H29)
Public Const vGoToXYRef         As Integer = (&H2B)
Public Const bReadEditString    As Integer = (&H2D)
Public Const vSetEditString     As Integer = (&H2F)
Public Const bGetEditString     As Integer = (&H31)
Public Const vDispStr           As Integer = (&H33)
Public Const vDispCh            As Integer = (&H35)
Public Const vDispClrLn         As Integer = (&H37)

'COM1 e COM2

Public Const vSetEnableSerial   As Integer = (&H39)
Public Const bGetEnableSerial   As Integer = (&H3B)
Public Const bGetBinSerial      As Integer = (&H3D)
Public Const bSendBinSerial     As Integer = (&H3F)
Public Const bSetSetupSerial    As Integer = (&H41)
Public Const vGetSetupSerial    As Integer = (&H43)

'LPT1

Public Const cInitPrn           As Integer = (&H45)
Public Const cGetStatusPrn      As Integer = (&H71)
Public Const cSendPrn           As Integer = (&H73)

'Estrutura que armazena a configurao do terminal

Public Type TSetupTCP
   microT_IP                    As Long
   server_IP                    As Long
   msknet_IP                    As Long
   bDHCP                        As Integer
End Type

Public conf                     As TSetupTCP

'Sockets Conectados



Public Type TExSetupTCP
    gateway                      As Long    'IP do gateway
    nameserver                   As Long    'IP do servidor de nomes
    myname                       As Long    'Nome do terminal
End Type

Public config                    As TExSetupTCP


Public Type TTABSOCK
    TabSock                     As Long
    TabIP                       As Long
    TabVs                       As Integer
    HeartBeat                   As Boolean
End Type

Public tabcon(0 To 255)         As TTABSOCK

'Quantidade de terminais conectados

Public intMax                   As Integer
Public qtabcon                  As Integer
Public tmr                      As Integer

Public Type ARG_BYTE_BYTE
    cArg1                      As Byte
    cArg2                      As Byte
End Type

Public Type DispEnvStr
    ID As Integer
    Tam As Integer
    arg As String
End Type


Public Type ARG_STR_BYTE
    Bin                         As String
    Tam                         As Byte
End Type


Public Type ARG_BYTE_BOOL
    Com                         As Byte
    bOnOff                      As Long
End Type

'Converte uma string que contenha um endereo de IP em um endereo correto de 4 bytes.
Public Declare Function inet_addr Lib "WSOCK32.DLL" (ByVal cp As String) As Long
'
'
'********************************************************************************************************

'********************************************************************************************************
' Funo: InverteIP
'********************************************************************************************************
'
' Data de Criao: 3/5/2007
'
' Autor: Flvia C. Montagneri
'
' Entrada: String
'
' Sada: String
'
' Descrio: Inverte os blocos do IP no formato utilizado pelo protocolo do GE
'
' Observao: Funo InverteIP - Funo que inverte os blocos do IP (criada neste software)
'             Estrutura: InverteIP(a)
'             Onde: a -> String com IP que deseja inverter, por exemplo:
'                de 192.168.0.10 para 10.0.168.192, pois  assim que o terminal trabalha
'
'             Funo inet_addr - Converte uma string que contenha um endereo de IP em um endereo correto de 4 bytes.
'             Estrutura: inet_addr(a)
'             Onde: a -> String que contm o endereo de IP
'
'********************************************************************************************************

Public Function Compara(Str As String) As Byte
    If (Str = "0" Or Str = "1" Or Str = "2" Or Str = "3" Or Str = "4" Or Str = "5" Or Str = "6" Or Str = "7" Or Str = "8" Or Str = "9") Or ((Str = "a") Or (Str = "b") Or (Str = "c") Or (Str = "d") Or (Str = "d") Or (Str = "f")) Or ((Str = "A") Or (Str = "B") Or (Str = "C") Or (Str = "D") Or (Str = "E") Or (Str = "F")) Then
       Compara = 1
    Else
       Compara = 0
    End If
End Function


Public Function Converte(Str As String) As Byte
  Dim str1 As String
  Dim str1a As Integer
  Dim str2 As String
  Dim str2a As Integer
  Dim soma As Integer
  
str1 = (Mid(Str, 1, 1))
str2 = (Mid(Str, 2, 1))
   
   Select Case str1
      Case (0): str1a = 0
      Case (1): str1a = 16
      Case (2): str1a = 32
      Case (3): str1a = 48
      Case (4): str1a = 64
      Case (5): str1a = 80
      Case (6): str1a = 96
      Case (7): str1a = 112
      Case (8): str1a = 128
      Case (9): str1a = 144
      Case ("a"): str1a = 160
      Case ("b"): str1a = 176
      Case ("c"): str1a = 192
      Case ("d"): str1a = 208
      Case ("e"): str1a = 224
      Case ("f"): str1a = 240
   End Select
   
      Select Case str2
      Case (0): str2a = 0
      Case (1): str2a = 1
      Case (2): str2a = 2
      Case (3): str2a = 3
      Case (4): str2a = 4
      Case (5): str2a = 5
      Case (6): str2a = 6
      Case (7): str2a = 7
      Case (8): str2a = 8
      Case (9): str2a = 9
      Case ("a"): str2a = 10
      Case ("A"): str2a = 10
      Case ("b"): str2a = 11
      Case ("B"): str2a = 11
      Case ("c"): str2a = 12
      Case ("C"): str2a = 12
      Case ("d"): str2a = 13
      Case ("D"): str2a = 13
      Case ("e"): str2a = 14
      Case ("E"): str2a = 14
      Case ("f"): str2a = 15
      Case ("F"): str2a = 15
   End Select
   
   soma = str1a + str2a
      
Converte = soma

End Function
Public Function InverteIP(Str As String) As String

  Dim aux As String
  Dim ip As String
  Dim i As Integer
  Dim j As Integer
  Dim k As Integer

  i = 1
  
  Do While ((Mid(Str, i, 1) <> ""))
    
    'Armazena o ndice do primeiro caracter do bloco
    k = i
    
    'Conta a quantidade de caracteres do bloco separado por ponto <.>
    Do While ((Mid(Str, i, 1) <> ".") And (Mid(Str, i, 1) <> ""))
      i = i + 1
    Loop
    
    'Limpa string auxliar que armazena o bloco
    aux = ""
    
    'Armazena o bloco
    For j = k To (i - 1)
      aux = aux & Mid(Str, (j), 1)
    Next
    
    'Joga o bloco dentro do ip, j efetuando a inverso
    ip = aux & ip
    
    If (Mid(Str, i, 1) <> "") Then
      i = i + 1
      ip = "." & ip
    End If
    
  Loop
  
  InverteIP = ip

End Function
'
'********************************************************************************************************


