VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls_Ini"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************
' Projeto   :          Classe para manipular arquivos INI
' Arquivo   :          AZFood TAD
' Data Criao :       24/01/2008
' Verso :             0.0.0.1
' Reviso :
' Data   :             24/01/2008
' Modificaes :
'*************************************************************************

Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Private Declare Function GetModuleFileName Lib "kernel32" Alias _
    "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, _
    ByVal nSize As Long) As Long
    
Private Declare Function GetModuleHandle Lib "kernel32" Alias _
    "GetModuleHandleA" (ByVal lpModuleName As String) As Long
    
'********************************************************************************************************
'                               ***** ReadIni() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Nome do arquivo, seo e palavra-chave
' Sada: void
' Descrio: reads ini string
'********************************************************************************************************
Public Function ReadIni(FileName As String, Section As String, Key As String) As String
Dim RetVal As String * 255, v As Long
    v = GetPrivateProfileString(Section, Key, "", RetVal, 255, FileName)
    ReadIni = Left(RetVal, v)
End Function
'********************************************************************************************************
'                               ***** ReadIniSection() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Nome do arquivo, seo
' Sada: void
' Descrio: reads ini section
'********************************************************************************************************
Public Function ReadIniSection(FileName As String, Section As String) As String
Dim RetVal As String * 255, v As Long
v = GetPrivateProfileSection(Section, RetVal, 255, FileName)
ReadIniSection = Left(RetVal, v - 1)
End Function
'********************************************************************************************************
'                               ***** WriteIni() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Nome do arquivo, seo e palavra-chave
' Sada: void
' Descrio: writes ini
'********************************************************************************************************
Public Sub WriteIni(FileName As String, Section As String, Key As String, Value As String)
    WritePrivateProfileString Section, Key, Value, FileName
End Sub
'********************************************************************************************************
'                               ***** WriteIniSection() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Nome do arquivo, seo e valor a ser passado
' Sada: void
' Descrio: writes ini section
'********************************************************************************************************
Public Sub WriteIniSection(FileName As String, Section As String, Value As String)
    WritePrivateProfileSection Section, Value, FileName
End Sub

'********************************************************************************************************
'                               ***** GetAppFilename() *****
'********************************************************************************************************
' Data de Criao:
' Autor:
' Entrada: Nome do arquivo, seo e valor a ser passado
' Sada: void
' Descrio: ' return the application's filename
'********************************************************************************************************
Function GetAppFilename() As String
    Dim hModule As Long
    Dim buffer As String * 256
    hModule = GetModuleHandle(App.EXEName)
    GetModuleFileName hModule, buffer, Len(buffer)
    GetAppFilename = Left$(buffer, InStr(buffer & vbNullChar, vbNullChar) - 1)
End Function
